/*
 * barrier.h
 *
 *  Created on: 21-set-2009
 *      Author: gio
 */

#ifndef BARRIER_H_
#define BARRIER_H_


class Barrier : public JTCMonitor

{
	int nthreads;
	int threadsFinished;
public:
	Barrier(int nt)
	{
		nthreads = nt;
		threadsFinished = 0;
	};
	void done()
	{
		JTCSynchronized sync(*this);
		threadsFinished++;
		if (threadsFinished == nthreads)
			notify();
	}
	void waitForCompletion()
	{
		JTCSynchronized sync(*this);
		if (threadsFinished < nthreads)
			wait();
	}
	void reset()
	{
		JTCSynchronized sync(*this);
		if (threadsFinished == nthreads)
			threadsFinished = 0;
	}

};



#endif /* BARRIER_H_ */
